/* Part of gjrand random number library version 3.4.0.0 or later. */
/* Copyright (C) 2004-2010 G. Jones. */
/* Licensed under the GNU General Public License version 2 or 3. */

#include "gjrand.h"
#include "inte.h"

#define MULT (1017.0/1024.0)

double
gjrand_exponential(struct gjrand *g)
{
    uint64_t a, b, c, d;
    double r=0, s=0, t=0, u=0;
    uint64_t ir, is, it, iu;
    int jr, js, jt, ju;
    int j;

    GJRAND_INTE_LOADSTATE(g, a, b, c, d);
    GJRAND_INTE_CRANK(a, b, c, d); ir = a;
    GJRAND_INTE_CRANK(a, b, c, d); is = a;
    GJRAND_INTE_CRANK(a, b, c, d); it = a;
    GJRAND_INTE_CRANK(a, b, c, d); iu = a;
    GJRAND_INTE_STORESTATE(g, a, b, c, d);

    j = 8;
    goto start;
    do
    {
	ir >>= 8; is >>= 8; it >>= 8; iu >>= 8;
	r *= MULT; s *= MULT; t *= MULT; u *= MULT;
	start:
	jr = ir&255; js = is&255; jt = it&255; ju = iu&255;
	r += gjrand_inte_normal_app[jr];
	s += gjrand_inte_normal_app[js];
	t += gjrand_inte_normal_app[jt];
	u += gjrand_inte_normal_app[ju];
	j--;
    } while (j);

    r += s*(MULT*MULT*MULT*MULT*MULT*MULT*MULT*MULT);
    t += u*(MULT*MULT*MULT*MULT*MULT*MULT*MULT*MULT);

    return (r*r+t*t) * (GJRAND_INTE_NORM_ADJ*GJRAND_INTE_NORM_ADJ*0.5);
}
