#include <math.h>
#include "nonstd.h"

/* This is straight out of the GSL version 1.9 code, */
/* copyright Gerard Jungman and Brian Gough 1996-2000. */
/* Released by them under GPL version 2 or later. */
/* I'm not sure if it actually meets IEEE accuracy for double precision */
/* but if it doesn't it appears to be very close. */
/* That's plenty good enough for gjrand. */
/* If you have this function available with your vendor's libraries */
/* that version will likely be faster and possibly more accurate. */
/* (If your vendor gave you something worse than this, or nothing at all, */
/* complain very loudly.) */
double
log1p (const double x)
{
  volatile double y, z;
  y = 1 + x;
  z = y - 1;
  return log(y) - (z-x)/y ;  /* cancels errors with IEEE arithmetic */
}
