/* Part of gjrand random number library version 3.4.0.0 or later. */
/* Copyright (C) 2004-2011 G. Jones. */
/* Licensed under the GNU General Public License version 2 or 3. */

#include "gjrand.h"
#include "inte.h"

#define MULT (1017.0/1024.0)

double
gjrand_normal(struct gjrand *g)
{
    uint64_t a, b, c, d;
    double r=0, s=0;
    uint64_t ir, is;
    int jr, js;
    int j;

    GJRAND_INTE_LOADSTATE(g, a, b, c, d);
    GJRAND_INTE_CRANK(a, b, c, d); ir = a;
    GJRAND_INTE_CRANK(a, b, c, d); is = a;
    GJRAND_INTE_STORESTATE(g, a, b, c, d);

    j = 8;
    goto start;
    do
    {
	ir >>= 8; is >>= 8;
	r *= MULT; s *= MULT;
	start:
	jr = ir&255; js = is&255;
	r += gjrand_inte_normal_app[jr];
	s += gjrand_inte_normal_app[js];
	j--;
    } while (j);

    r += s*(MULT*MULT*MULT*MULT*MULT*MULT*MULT*MULT);

    return r * GJRAND_INTE_NORM_ADJ;
}
