/* Part of gjrand random number library version 4.0.2.0 or later. */
/* Copyright (C) 2004-2013 G. Jones. */
/* Licensed under the GNU General Public License version 2 or 3. */

#include "gjrand.h"
#include "inte.h"

#define MULT (1017.0/1024.0)

GJRAND_STATIC void
gjrand_inte_normalvs(struct gjrand *g, int n, double *v)
{
    uint64_t a, b, c, d;
    double r, s;
    uint64_t ir, is;
    int jr, js;
    int j;

    if (n<=0) return;

    GJRAND_INTE_LOADSTATE(g, a, b, c, d);

    do
    {
	GJRAND_INTE_CRANK(a, b, c, d); ir = a;
	GJRAND_INTE_CRANK(a, b, c, d); is = a;
	j = 8; r = s = 0;
	goto start;
	do
	{
	    ir >>= 8; is >>= 8;
	    r *= MULT; s *= MULT;
	    start:
	    jr = ir&255; js = is&255;
	    r += gjrand_inte_normal_app[jr];
	    s += gjrand_inte_normal_app[js];
	    j--;
	} while (j);

	*v = (r + s*(MULT*MULT*MULT*MULT*MULT*MULT*MULT*MULT))
		* GJRAND_INTE_NORM_ADJ;

	v++; n--;
    } while (n!=0);

    GJRAND_INTE_STORESTATE(g, a, b, c, d);
}
