/* Miscellaneous stuff for gjrand random numbers version 3.3.2.0 or later. */
/* Copyright (C) 2004-2010 G. Jones. */
/* Licensed under the GNU General Public License version 2 or 3. */

#include <stdlib.h>
#include <stdio.h>
#include <time.h>

#include "../../src/my_int_types.h"

/* This one writes data for use by the tests in testunif */

/* second optional arg is random seed. */
/* This attempts to write forever. */

/* This is a linear congruential generator. */
/* These tend to be very weak in the least significant bits */
/* and reasonably good in the more significant bits. */
/* This one returns the most significant 32 bits out of 64. */
/* This is bordering on acceptable, but might still cause trouble in */
/* the most demanding applications. */

/* selfcor -r complains loudest, rejecting it somewhere less than 1GB. */
/* DIEHARD is happy. Neither gzip nor bzip2 can compress it. */

static void
blat(uint32_t seed)
{
    uint32_t buf[1024];
    uint64_t j=seed;

    while (1)
    {
	int i= -1024;
	do
	{
	    j=j*3098765421UL+1;
	    (buf+1024)[i]=j>>32;
	    i++;
	} while (i<0);

	if (fwrite(buf, 1, 4096, stdout)!=4096) break;
    }
}

int
main(int argc, char **argv)
{
    unsigned long seed;

    if (argc>1) sscanf(argv[1], "%lu", &seed);
    else seed = time(0);

    blat(seed);

    return 0;
}
